unit uPrincipal;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QDBCtrls, DB, SqlExpr, QStdCtrls, QExtCtrls, QGrids, QMask, QMenus,
  QTypes;

type
  TfPrincipal = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    butFechar: TButton;
    conn: TSQLConnection;
    sql: TSQLQuery;
    source: TDataSource;
    dbnav: TDBNavigator;
    GridVer: TStringGrid;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    butIns: TButton;
    edtNome: TMaskEdit;
    edtTel: TMaskEdit;
    PopupMenu1: TPopupMenu;
    Editar1: TMenuItem;
    Deletar1: TMenuItem;
    procedure butFecharClick(Sender: TObject);
    procedure butInsClick(Sender: TObject);
    procedure verdados(a:integer);
    procedure FormShow(Sender: TObject);
    procedure Deletar1Click(Sender: TObject);
    procedure Editar1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fPrincipal: TfPrincipal;

implementation

uses uEdita;

{$R *.xfm}

procedure TfPrincipal.verdados(a:integer);
var gridlarg,gridcol,registros,id,c:integer;
begin
 //atribuindo os valoes para acertar o grid:
 gridlarg:= gridver.Width;
 gridver.DefaultColWidth:= trunc(gridlarg/2) - 15;

 //contando o numero de regisros do mysql:
 sql.SQL.Text:= 'select * from telefones';
 sql.Open;
 registros:= sql.RecordCount;

 //inserindo as linhas necessarias no gridver:
 gridver.RowCount:= registros + 1;

 //inserindo os valores no gridver
 gridver.Cells[0,0]:= 'Nomes:';
 gridver.Cells[1,0]:= 'Telefones:';
 id:= 0;
 c:= 1;
 sql.SQL.Text:= 'select * from telefones order by agenda_nome';
 sql.Open;
 while (id <= registros) do
  begin
   gridver.Cells[0,c]:= sql.Fields.Fields[1].AsString;
   gridver.Cells[1,c]:= sql.Fields.Fields[2].AsString;
   id:= id + 1;
   c:= c + 1;
   dbnav.BtnClick(nbNext);
  end;
end;

procedure TfPrincipal.butFecharClick(Sender: TObject);
begin
if messagedlg('Deseja realmente fechar esse programa?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
 begin
  Application.Terminate;
 end;
end;

procedure TfPrincipal.butInsClick(Sender: TObject);
var nome, tel: string; //Aqui eu declaro as variaveis que vou usar para os dados
    erro: integer; //Essa varivel vou usar como controle de erros
begin
//Capturando os valores e jogando nas variaveis
nome:= trim(edtNome.Text);
tel:= trim(edtTel.Text);
erro:= 0;

//verificando se a variavel nome est vazia ou no:
//se estiver vazia, dou valor 1 para o erro, uma mensagem  exibida e o programa no acessa o mysql.
if (nome='') then
 begin
  ShowMessage('Voce precisa digitar um nome!');
  erro:= 1;
 end;

//verificando se a variavel tel est vazia ou no:
//se estiver vazia, dou valor 1 para o erro, uma mensagem  exibida e o programa no acessa o mysql.
if (tel='(  )    -') then
 begin
  ShowMessage('Voce precisa digitar um telefone!');
  erro:= 1;
 end;

//verificando se houve erro na validao. Se houve no faz nada
//Se no houve erro, prossegue com o mysql.
if (erro=0) then
 begin
  //criando a string MySQL:
  sql.SQL.Text:= 'INSERT INTO telefones(agenda_id,agenda_nome,agenda_tel) VALUES(0,'+quotedstr(nome)+','+quotedstr(tel)+')';
  //executando a string:
  sql.ExecSQL(True);
  //limpando os edits:
  edtNome.Text:= '';
  edtTel.Text:= '';
  //informando o sucesso da operao:
  showmessage('Cadastrado com sucesso!');
  verdados(1); //<--- AQUI
 end;
end;

procedure TfPrincipal.FormShow(Sender: TObject);
begin
 verdados(1);
end;

procedure TfPrincipal.Deletar1Click(Sender: TObject);
var deletar:string;
begin
 //captura o numero do telefone a ser deletado
 deletar:= gridver.Cells[1,gridver.Row];

 //confirma se deseja deletar ou no:
 if messagedlg('Deseja realmente remover o telefone ' + deletar,mtConfirmation,[mbYes,mbNo],0)=mrYes then
  begin
   sql.SQL.Text:= 'delete from telefones where agenda_tel = ' + quotedstr(deletar);
   //sql.Open;
   sql.ExecSQL(True);
   verdados(1);
  end;
end;

procedure TfPrincipal.Editar1Click(Sender: TObject);
begin
 //preenche os edits
 fEdita.edtNome.Text:= gridver.Cells[0,gridver.Row];
 fEdita.edtTel.Text:= gridver.Cells[1,gridver.Row];
 fEdita.ShowModal;
end;

end.
